require 'universal-git-client/client'
require 'universal-git-client/http/github'
require 'universal-git-client/http/gitlab'
require 'universal-git-client/http/bitbucket'
require 'universal-git-client/http/bitbucket_server'

module UniversalGitClient
  class ClientFactory
    class << self
      def build(provider, *args)
        case provider
        when :github
          Client.new('GitHub', UniversalGitClient::Http::Github.new(*args))
        when :gitlab
          Client.new('GitLab', UniversalGitClient::Http::Gitlab.new(*args))
        when :bitbucket
          Client.new('Bitbucket', UniversalGitClient::Http::Bitbucket.new(*args))
        when :bitbucket_server
          Client.new('Bitbucket Server', UniversalGitClient::Http::BitbucketServer.new(*args))
        else
          raise ArgumentError, 'Unknown provider'
        end
      end
    end
  end
end
