require 'universal-git-client/normalizers/base'

module UniversalGitClient
  module Normalizers
    class Github < Base
      class UserSerializer < BaseSerializer
        attributes :login, :name, :avatar_url
      end

      class OrganizationSerializer < BaseSerializer
        attributes :login, :avatar_url
      end

      class RepositorySerializer < BaseSerializer
        attributes :name, :full_name, :private, :archived, :default_branch
        attribute :full_path, &:full_name
      end

      class BranchSerializer < BaseSerializer
        set_id :name
        attributes :name, :commit, :protected
        attribute :commit do |object|
          object.commit.sha
        end
      end

      class WebhookSerializer < BaseSerializer
        attributes :type, :url, :secret, :events, :active
        attribute :url do |object|
          object.config.url
        end
      end
    end
  end
end
